package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialAthlete;
import org.springblade.modules.martial.service.IMartialAthleteService;
import org.springframework.web.bind.annotation.*;

/**
 * 参赛选手 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/athlete")
@Tag(name = "参赛选手管理", description = "参赛选手接口")
public class MartialAthleteController extends BladeController {

	private final IMartialAthleteService athleteService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialAthlete> detail(@RequestParam Long id) {
		MartialAthlete detail = athleteService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialAthlete>> list(MartialAthlete athlete, Query query) {
		IPage<MartialAthlete> pages = athleteService.page(Condition.getPage(query), Condition.getQueryWrapper(athlete));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialAthlete athlete) {
		return R.status(athleteService.saveOrUpdate(athlete));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(athleteService.removeByIds(Func.toLongList(ids)));
	}

}
